<ui:composition xmlns:g="http://www.ihe.net/gazelle"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <s:token allowMultiplePosts="true"/>
            <s:div id="globalDiv">

                <h1>
                    <span class="fa fa-wrench" style="font-size: 1em;"/>
                    #{messages['net.ihe.gazelle.proxy.ManageApplicationPreferences']}
                </h1>

                <p>
                    <a4j:commandButton action="#{applicationManager.createNewPreference()}"
                                       styleClass="gzl-btn-blue" execute="settingsToken"
                                       value="#{messages['net.ihe.gazelle.proxy.AddAPreference']}"
                                       oncomplete="jq162('#addPrefModal').modal('show');"
                                       render="prefInputs"/>
                </p>


                <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                    <ui:param name="panel_id" value="prefPanel"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.ApplicationPreferences']}"/>
                    </ui:define>
                    <rich:dataTable id="prefList" value="#{applicationManager.getAllPreferences()}"
                                    var="pref" render="ds"
                                    rows="#{dataScrollerMemory.numberOfResultsPerPage}">
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.proxy.NameuniqueKey']})</ui:define>
                            <h:outputText value="#{pref.variable}"/>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.proxy.Value']}</ui:define>
                            <rich:inplaceInput value="#{pref.value}" defaultLabel="&#160;&#160;&#160;&#160;"
                                               showControls="true"
                                               title="#{messages['net.ihe.gazelle.atna.ClickToEdit']}">
                                <a4j:ajax event="change" render="globalDiv"
                                          listener="#{applicationManager.updatePreference(pref)}"/>
                            </rich:inplaceInput>
                        </g:column>
                        <g:column>
                            <ui:define name="header">#{messages['net.ihe.gazelle.proxy.Action']}</ui:define>
                            <div class="gzl-never-wrap form-control-static">
                                <a4j:commandLink event="click" title="#{messages['net.ihe.gazelle.proxy.Delete']}"
                                                 oncomplete="jq162('#delPrefModal').modal('show');"
                                                 render=" :prefOutputs" execute="@this"
                                                 actionListener="#{applicationManager.setPreference(pref) }">
                                    <span class="gzl-icon-trash-o"/>
                                </a4j:commandLink>
                            </div>
                        </g:column>
                        <f:facet name="footer">
                            <ui:include src="/util/datatableFooter.xhtml">
                                <ui:param name="dataScrollerId" value="ds"/>
                                <ui:param name="dataTableId" value="prefList"/>
                            </ui:include>
                        </f:facet>
                    </rich:dataTable>
                </ui:decorate>

                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="addPrefModal"/>
                    <ui:define name="popup_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.NewApplicationPreference']}"/>
                    </ui:define>

                    <s:div id="prefInputs" styleClass="form-horizontal">
                        <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                            <ui:param name="id" value="inputVaria"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.PreferenceNameuniqueKey']})
                            </ui:define>
                            <h:inputText id="inputVaria" type="text" styleClass="form-control"
                                         value="#{applicationManager.preference.variable}"/>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                            <ui:param name="id" value="inputValue"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Value']}</ui:define>
                            <h:inputText id="inputValue" styleClass="form-control"
                                         value="#{applicationManager.preference.value}"/>
                        </s:decorate>
                    </s:div>

                    <ui:define name="popup_footer">
                        <a4j:commandButton styleClass="gzl-btn"
                                           value="#{messages['net.ihe.gazelle.proxy.Cancel']}"
                                           actionListener="#{applicationManager.setPreference(null)}"
                                           oncomplete="jq162('#addPrefModal').modal('hide')"/>
                        <a4j:commandButton styleClass="gzl-btn-green"
                                           value="#{messages['net.ihe.gazelle.proxy.Save']}"
                                           action="#{applicationManager.savePreference(applicationManager.preference)}"
                                           oncomplete="jq162('#addPrefModal').modal('hide')"
                                           render="prefList"/>
                    </ui:define>
                </ui:decorate>

                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="delPrefModal"/>
                    <ui:define name="popup_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.RemovePreference']}"/>
                    </ui:define>

                    <s:div id="prefOutputs" styleClass="form-horizontal">
                        <s:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.PreferenceNameuniqueKey']})
                            </ui:define>
                            <h:outputText value="#{applicationManager.preference.variable}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Value']}</ui:define>
                            <h:outputText value="#{applicationManager.preference.value}"/>
                        </s:decorate>
                    </s:div>

                    <ui:define name="popup_footer">
                        <a4j:commandButton styleClass="gzl-btn"
                                           value="#{messages['net.ihe.gazelle.proxy.Cancel']}"
                                           actionListener="#{applicationManager.setPreference(null)}"
                                           oncomplete="jq162('#delPrefModal').modal('hide')"/>
                        <a4j:commandButton styleClass="gzl-btn-red"
                                           value="#{messages['net.ihe.gazelle.proxy.Remove']}"
                                           action="#{applicationManager.removeSelectedPreference()}"
                                           oncomplete="jq162('#delPrefModal').modal('hide')"
                                           render="prefList"/>
                    </ui:define>
                </ui:decorate>

            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
